{-# OPTIONS_GHC -w #-}
{-# OPTIONS -fglasgow-exts -cpp #-}
module Language.Fortran.Parser.Fortran66(expressionParser,
                               statementParser,
                               fortran66Parser) where

import Prelude hiding (EQ,LT,GT) -- Same constructors exist in the AST

import Control.Monad.State
import Data.Maybe (isNothing, fromJust)
import qualified Data.ByteString.Char8 as B
import Language.Fortran.Util.Position
import Language.Fortran.ParserMonad
import Language.Fortran.Lexer.FixedForm
import Language.Fortran.Transformer (transform, Transformation(..))
import Language.Fortran.AST
import qualified Data.Array as Happy_Data_Array
import qualified GHC.Exts as Happy_GHC_Exts
import Control.Applicative(Applicative(..))
import Control.Monad (ap)

-- parser produced by Happy Version 1.19.5

newtype HappyAbsSyn  = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = Happy_GHC_Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn6 :: (ProgramFile A0) -> (HappyAbsSyn )
happyIn6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn ) -> (ProgramFile A0)
happyOut6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: (ProgramFile A0) -> (HappyAbsSyn )
happyIn7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn ) -> (ProgramFile A0)
happyOut7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: ([ ([ Block A0 ], ProgramUnit A0) ]) -> (HappyAbsSyn )
happyIn8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn ) -> ([ ([ Block A0 ], ProgramUnit A0) ])
happyOut8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: (ProgramUnit A0) -> (HappyAbsSyn )
happyIn9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn ) -> (ProgramUnit A0)
happyOut9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: (ProgramUnit A0) -> (HappyAbsSyn )
happyIn10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn ) -> (ProgramUnit A0)
happyOut10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: (Maybe (AList Expression A0)) -> (HappyAbsSyn )
happyIn11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn ) -> (Maybe (AList Expression A0))
happyOut11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: (Name) -> (HappyAbsSyn )
happyIn12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn ) -> (Name)
happyOut12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: ([ Block A0 ]) -> (HappyAbsSyn )
happyIn13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn ) -> ([ Block A0 ])
happyOut13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: (Block A0) -> (HappyAbsSyn )
happyIn14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn ) -> (Block A0)
happyOut14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: (Maybe Token) -> (HappyAbsSyn )
happyIn15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn ) -> (Maybe Token)
happyOut15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: (Token) -> (HappyAbsSyn )
happyIn16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn ) -> (Token)
happyOut16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: (Statement A0) -> (HappyAbsSyn )
happyIn17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn ) -> (Statement A0)
happyOut17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: (Statement A0) -> (HappyAbsSyn )
happyIn18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn ) -> (Statement A0)
happyOut18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: (Statement A0) -> (HappyAbsSyn )
happyIn19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn ) -> (Statement A0)
happyOut19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: (DoSpecification A0) -> (HappyAbsSyn )
happyIn20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn ) -> (DoSpecification A0)
happyOut20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: (Expression A0) -> (HappyAbsSyn )
happyIn21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn ) -> (Expression A0)
happyOut21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: (Statement A0) -> (HappyAbsSyn )
happyIn22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn ) -> (Statement A0)
happyOut22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: (Statement A0) -> (HappyAbsSyn )
happyIn23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn ) -> (Statement A0)
happyOut23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: (Statement A0) -> (HappyAbsSyn )
happyIn24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn ) -> (Statement A0)
happyOut24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: ((AList ControlPair A0, Maybe (AList Expression A0))) -> (HappyAbsSyn )
happyIn25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn ) -> ((AList ControlPair A0, Maybe (AList Expression A0)))
happyOut25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: (Expression A0) -> (HappyAbsSyn )
happyIn26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn ) -> (Expression A0)
happyOut26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: (Expression A0) -> (HappyAbsSyn )
happyIn27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn ) -> (Expression A0)
happyOut27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: (Expression A0) -> (HappyAbsSyn )
happyIn29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn ) -> (Expression A0)
happyOut29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: (Expression A0) -> (HappyAbsSyn )
happyIn30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn ) -> (Expression A0)
happyOut30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: (AList DataGroup A0) -> (HappyAbsSyn )
happyIn31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn ) -> (AList DataGroup A0)
happyOut31 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut32 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyIn33 :: (Expression A0) -> (HappyAbsSyn )
happyIn33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn33 #-}
happyOut33 :: (HappyAbsSyn ) -> (Expression A0)
happyOut33 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut33 #-}
happyIn34 :: (Expression A0) -> (HappyAbsSyn )
happyIn34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn34 #-}
happyOut34 :: (HappyAbsSyn ) -> (Expression A0)
happyOut34 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut34 #-}
happyIn35 :: (AList (AList Expression) A0) -> (HappyAbsSyn )
happyIn35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn35 #-}
happyOut35 :: (HappyAbsSyn ) -> (AList (AList Expression) A0)
happyOut35 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut35 #-}
happyIn36 :: (AList CommonGroup A0) -> (HappyAbsSyn )
happyIn36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn36 #-}
happyOut36 :: (HappyAbsSyn ) -> (AList CommonGroup A0)
happyOut36 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut36 #-}
happyIn37 :: (CommonGroup A0) -> (HappyAbsSyn )
happyIn37 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn37 #-}
happyOut37 :: (HappyAbsSyn ) -> (CommonGroup A0)
happyOut37 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut37 #-}
happyIn38 :: (CommonGroup A0) -> (HappyAbsSyn )
happyIn38 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn38 #-}
happyOut38 :: (HappyAbsSyn ) -> (CommonGroup A0)
happyOut38 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut38 #-}
happyIn39 :: (Expression A0) -> (HappyAbsSyn )
happyIn39 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn39 #-}
happyOut39 :: (HappyAbsSyn ) -> (Expression A0)
happyOut39 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut39 #-}
happyIn40 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn40 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn40 #-}
happyOut40 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut40 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut40 #-}
happyIn41 :: (Expression A0) -> (HappyAbsSyn )
happyIn41 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn41 #-}
happyOut41 :: (HappyAbsSyn ) -> (Expression A0)
happyOut41 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut41 #-}
happyIn42 :: (AList Declarator A0) -> (HappyAbsSyn )
happyIn42 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn42 #-}
happyOut42 :: (HappyAbsSyn ) -> (AList Declarator A0)
happyOut42 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut42 #-}
happyIn43 :: (Declarator A0) -> (HappyAbsSyn )
happyIn43 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn43 #-}
happyOut43 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut43 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut43 #-}
happyIn44 :: (AList Declarator A0) -> (HappyAbsSyn )
happyIn44 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn44 #-}
happyOut44 :: (HappyAbsSyn ) -> (AList Declarator A0)
happyOut44 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut44 #-}
happyIn45 :: (Declarator A0) -> (HappyAbsSyn )
happyIn45 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn45 #-}
happyOut45 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut45 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut45 #-}
happyIn46 :: (AList DimensionDeclarator A0) -> (HappyAbsSyn )
happyIn46 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn46 #-}
happyOut46 :: (HappyAbsSyn ) -> (AList DimensionDeclarator A0)
happyOut46 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut46 #-}
happyIn47 :: (DimensionDeclarator A0) -> (HappyAbsSyn )
happyIn47 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn47 #-}
happyOut47 :: (HappyAbsSyn ) -> (DimensionDeclarator A0)
happyOut47 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut47 #-}
happyIn48 :: (Declarator A0) -> (HappyAbsSyn )
happyIn48 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn48 #-}
happyOut48 :: (HappyAbsSyn ) -> (Declarator A0)
happyOut48 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut48 #-}
happyIn49 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn49 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn49 #-}
happyOut49 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut49 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut49 #-}
happyIn50 :: (AList Argument A0) -> (HappyAbsSyn )
happyIn50 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn50 #-}
happyOut50 :: (HappyAbsSyn ) -> (AList Argument A0)
happyOut50 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut50 #-}
happyIn51 :: (AList Argument A0) -> (HappyAbsSyn )
happyIn51 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn51 #-}
happyOut51 :: (HappyAbsSyn ) -> (AList Argument A0)
happyOut51 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut51 #-}
happyIn52 :: (Argument A0) -> (HappyAbsSyn )
happyIn52 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn52 #-}
happyOut52 :: (HappyAbsSyn ) -> (Argument A0)
happyOut52 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut52 #-}
happyIn53 :: (Expression A0) -> (HappyAbsSyn )
happyIn53 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn53 #-}
happyOut53 :: (HappyAbsSyn ) -> (Expression A0)
happyOut53 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut53 #-}
happyIn54 :: (BinaryOp) -> (HappyAbsSyn )
happyIn54 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn54 #-}
happyOut54 :: (HappyAbsSyn ) -> (BinaryOp)
happyOut54 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut54 #-}
happyIn55 :: (Expression A0) -> (HappyAbsSyn )
happyIn55 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn55 #-}
happyOut55 :: (HappyAbsSyn ) -> (Expression A0)
happyOut55 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut55 #-}
happyIn56 :: ([ Index A0 ]) -> (HappyAbsSyn )
happyIn56 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn56 #-}
happyOut56 :: (HappyAbsSyn ) -> ([ Index A0 ])
happyOut56 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut56 #-}
happyIn57 :: ((SrcSpan, UnaryOp)) -> (HappyAbsSyn )
happyIn57 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn57 #-}
happyOut57 :: (HappyAbsSyn ) -> ((SrcSpan, UnaryOp))
happyOut57 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut57 #-}
happyIn58 :: (Maybe (AList Expression A0)) -> (HappyAbsSyn )
happyIn58 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn58 #-}
happyOut58 :: (HappyAbsSyn ) -> (Maybe (AList Expression A0))
happyOut58 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut58 #-}
happyIn59 :: ([ Expression A0 ]) -> (HappyAbsSyn )
happyIn59 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn59 #-}
happyOut59 :: (HappyAbsSyn ) -> ([ Expression A0 ])
happyOut59 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut59 #-}
happyIn60 :: (Expression A0) -> (HappyAbsSyn )
happyIn60 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn60 #-}
happyOut60 :: (HappyAbsSyn ) -> (Expression A0)
happyOut60 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut60 #-}
happyIn61 :: (Expression A0) -> (HappyAbsSyn )
happyIn61 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn61 #-}
happyOut61 :: (HappyAbsSyn ) -> (Expression A0)
happyOut61 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut61 #-}
happyIn62 :: (Expression A0) -> (HappyAbsSyn )
happyIn62 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn62 #-}
happyOut62 :: (HappyAbsSyn ) -> (Expression A0)
happyOut62 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut62 #-}
happyIn63 :: (Expression A0) -> (HappyAbsSyn )
happyIn63 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn63 #-}
happyOut63 :: (HappyAbsSyn ) -> (Expression A0)
happyOut63 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut63 #-}
happyIn64 :: (Expression A0) -> (HappyAbsSyn )
happyIn64 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn64 #-}
happyOut64 :: (HappyAbsSyn ) -> (Expression A0)
happyOut64 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut64 #-}
happyIn65 :: (Maybe (SrcSpan, String)) -> (HappyAbsSyn )
happyIn65 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn65 #-}
happyOut65 :: (HappyAbsSyn ) -> (Maybe (SrcSpan, String))
happyOut65 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut65 #-}
happyIn66 :: ((SrcSpan, String)) -> (HappyAbsSyn )
happyIn66 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn66 #-}
happyOut66 :: (HappyAbsSyn ) -> ((SrcSpan, String))
happyOut66 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut66 #-}
happyIn67 :: (Expression A0) -> (HappyAbsSyn )
happyIn67 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn67 #-}
happyOut67 :: (HappyAbsSyn ) -> (Expression A0)
happyOut67 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut67 #-}
happyIn68 :: (Expression A0) -> (HappyAbsSyn )
happyIn68 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn68 #-}
happyOut68 :: (HappyAbsSyn ) -> (Expression A0)
happyOut68 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut68 #-}
happyIn69 :: (Expression A0) -> (HappyAbsSyn )
happyIn69 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn69 #-}
happyOut69 :: (HappyAbsSyn ) -> (Expression A0)
happyOut69 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut69 #-}
happyIn70 :: (Expression A0) -> (HappyAbsSyn )
happyIn70 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn70 #-}
happyOut70 :: (HappyAbsSyn ) -> (Expression A0)
happyOut70 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut70 #-}
happyIn71 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn71 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn71 #-}
happyOut71 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut71 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut71 #-}
happyIn72 :: (AList Expression A0) -> (HappyAbsSyn )
happyIn72 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn72 #-}
happyOut72 :: (HappyAbsSyn ) -> (AList Expression A0)
happyOut72 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut72 #-}
happyIn73 :: (Expression A0) -> (HappyAbsSyn )
happyIn73 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn73 #-}
happyOut73 :: (HappyAbsSyn ) -> (Expression A0)
happyOut73 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut73 #-}
happyIn74 :: (Expression A0) -> (HappyAbsSyn )
happyIn74 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn74 #-}
happyOut74 :: (HappyAbsSyn ) -> (Expression A0)
happyOut74 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut74 #-}
happyIn75 :: (TypeSpec A0) -> (HappyAbsSyn )
happyIn75 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn75 #-}
happyOut75 :: (HappyAbsSyn ) -> (TypeSpec A0)
happyOut75 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut75 #-}
happyInTok :: (Token) -> (HappyAbsSyn )
happyInTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> (Token)
happyOutTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x8d\x03\xce\x01\x71\x00\x8d\x03\x8c\x03\x00\x00\x7b\x02\x00\x00\x71\x00\xc4\x03\x00\x00\x00\x00\x00\x00\x00\x00\x71\x00\x9d\x03\x02\x00\x00\x00\x00\x00\x00\x00\x71\x00\x00\x00\x89\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xba\x03\x00\x00\xc0\x03\x8a\x03\x9a\x03\x13\x00\xbd\x03\x87\x03\x00\x00\x00\x00\x97\x03\x97\x03\x96\x03\xb9\x03\xb9\x03\xec\xff\xec\xff\xec\xff\x66\x00\xb6\x03\x83\x03\x83\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x83\x03\x91\x03\x7d\x03\x00\x00\x00\x00\x00\x00\x9c\x00\x00\x00\x00\x00\x7c\x03\xce\x01\x07\x00\x7e\x03\x7e\x03\x79\x03\x79\x03\x79\x03\x00\x00\x00\x00\x9c\x00\x00\x00\xaf\x03\x5b\x00\x00\x00\x00\x00\xb0\x03\xad\x03\x00\x00\xae\x03\xab\x03\x00\x00\x9e\x03\x6c\x03\x74\x03\x00\x00\x5e\x03\x8f\x03\x37\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xec\xff\x00\x00\x50\x03\x00\x00\x00\x00\x00\x00\x7b\x03\x71\x00\x7a\x03\x44\x03\xd0\x02\x00\x00\x51\x03\x6d\x03\x6e\x03\x00\x00\x00\x00\x00\x00\x6b\x03\x68\x00\x71\x00\x73\x03\x00\x00\x09\x02\x00\x00\x41\x03\xe2\x00\x71\x00\x00\x00\x5f\x03\x00\x00\x5a\x03\x55\x03\x29\x03\x71\x00\x71\x00\x71\x00\x71\x00\x71\x00\x71\x00\x71\x00\x71\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x73\x03\x65\x03\x29\x03\x29\x03\x29\x03\x11\x02\x11\x02\x81\x03\xa1\x00\x4b\x03\x46\x03\x00\x00\x00\x00\x00\x00\x00\x00\x1e\x03\x57\x03\x57\x03\xc9\x02\x00\x00\x71\x00\x09\x03\x09\x03\x00\x00\x00\x00\x15\x03\x00\x00\x00\x00\xd4\x00\x00\x00\xbe\x02\x53\x00\x00\x00\x32\x03\xb6\x02\x04\x03\xf5\x02\xf5\x02\x23\x03\x00\x00\xeb\x02\xe7\xff\x9d\x02\x11\x03\xd7\x02\xd7\x02\x5c\x00\xd7\x02\x00\x00\xe2\x02\x00\x00\xe2\x02\xe2\x02\x07\x03\x00\x00\x07\x03\xcd\x02\xdd\x02\xc4\x02\xc4\x02\xf3\x02\xb5\x02\xc3\x02\xab\x02\xa0\x01\x4a\x00\x22\x00\x00\x00\x00\x00\xfe\xff\xbf\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa1\x00\x00\x00\x00\x00\x00\x00\xaa\x02\x00\x00\xaa\x02\xda\x02\x00\x00\xda\x02\x00\x00\x06\x00\xeb\xff\xe6\xff\x00\x00\x57\x03\x00\x00\x00\x00\x53\x00\xe8\x01\x00\x00\x00\x00\x00\x00\x8f\x02\x00\x00\x57\x03\x00\x00\x71\x00\x00\x00\x00\x00\xdc\x02\x00\x00\x57\x03\x00\x00\x71\x00\x00\x00\xd8\x02\xd3\x02\x00\x00\xd6\x02\x00\x00\x00\x00\xce\x02\x00\x00\x00\x00\xcb\x02\x00\x00\x00\x00\xc8\x02\x06\x00\xba\x02\x75\x02\x5c\x00\x00\x00\x00\x00\x5c\x00\x00\x00\x5c\x00\x8d\x02\x85\x02\xb9\x02\xb1\x02\x00\x00\x77\x02\x70\x02\x67\x02\x70\x01\x60\x02\x00\x00\x40\x01\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x8a\x02\x06\x00\x06\x00\xe6\xff\x71\x00\x6e\x02\x00\x00\x87\x02\xc5\x00\x00\x00\x83\x02\x00\x00\x06\x00\x00\x00\x4a\x02\x00\x00\x4a\x02\x10\x01\x4a\x02\x00\x00\x00\x00\x7d\x02\x74\x02\xcf\x00\x56\x02\x56\x02\x00\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x10\x02\x3a\x00\x3f\x03\x68\x02\x64\x02\x00\x00\x40\x02\x00\x00\x35\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x65\x01\x00\x00\x2d\x02\x00\x00\x00\x00\x00\x00\x2b\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb5\x00\x29\x02\x2f\x01\x00\x00\xea\x01\x00\x00\x00\x00\x30\x02\x08\x02\xd7\x01\x06\x02\xf2\x01\x05\x01\x65\x00\x52\x00\x3e\x02\xe6\x01\x2b\x00\x32\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x25\x02\x00\x00\x00\x00\x00\x00\x37\x01\x00\x00\x0e\x00\x00\x00\x00\x00\xf1\x01\x29\x00\xb5\x00\xed\x01\xcf\x01\xc4\x01\x05\x02\xc2\x01\x00\x00\x00\x00\xfd\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6c\x02\x21\x01\x00\x00\x66\x02\x00\x00\x75\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x48\x00\x00\x00\x33\x01\x00\x00\x00\x00\x00\x00\xdf\x01\x21\x03\x5f\x01\x6f\x01\x00\x00\x00\x00\x81\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x95\x01\x17\x03\x67\x01\x00\x00\x8e\x01\x00\x00\x5e\x01\x67\x01\x0d\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x67\x01\x03\x03\xf9\x02\xef\x02\xe5\x02\xdb\x02\xd1\x02\xc7\x02\xbd\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x67\x01\x67\x01\x67\x01\x67\x01\x67\x01\x67\x01\x67\x01\x67\x01\x61\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xdc\xff\x67\x01\x67\x01\x00\x00\x00\x00\x3b\x02\x0f\x01\x45\x01\x00\x00\x00\x00\x51\x01\x00\x00\x00\x00\x13\x01\x00\x00\x00\x00\x97\x02\x00\x00\x00\x00\x00\x00\x00\x00\x5f\x02\xff\x01\x00\x00\x00\x00\x2c\x02\x09\x01\x00\x00\x00\x00\x06\x01\x50\x00\xfa\x01\x1f\x02\x00\x00\x00\x00\x00\x00\x00\x00\x31\x01\x16\x01\x00\x00\xfe\x00\x0b\x01\xf1\x00\x00\x00\x00\x00\xdb\x00\xd1\x00\x9c\x01\xcd\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfd\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x35\x01\x00\x00\x00\x00\x00\x00\xe7\x01\x00\x00\xac\x00\x00\x00\x00\x00\x00\x00\x00\x00\xeb\x01\xee\xff\x39\x00\x00\x00\xa4\x00\x00\x00\x00\x00\x84\x02\xb0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa4\x00\x00\x00\xb3\x02\x00\x00\x00\x00\x00\x00\x00\x00\xa4\x00\x00\x00\x4d\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xad\x00\x00\x00\x00\x00\x1a\x02\x00\x00\x00\x00\x0c\x02\x00\x00\xec\x01\x6b\x01\xca\x00\x00\x00\x00\x00\x00\x00\x98\x00\x8b\x00\x85\x00\x1f\x00\x25\x00\x00\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb6\x00\x5d\x00\x2f\x00\xa9\x02\x0b\x00\x00\x00\x00\x00\x4d\x00\x00\x00\x00\x00\x00\x00\xb4\x00\x00\x00\x61\x01\x00\x00\x5d\x01\x1f\x00\xdf\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff\xff\xe5\xff\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\xec\xff\x00\x00\x00\x00\x00\x00\xec\xff\xe5\xff\x00\x00\x76\xff\x00\x00\x75\xff\x7a\xff\x79\xff\x78\xff\x77\xff\x00\x00\x00\x00\x61\xff\x54\xff\x69\xff\x6a\xff\x00\x00\x64\xff\x00\x00\xe4\xff\xe3\xff\xe2\xff\xda\xff\xe1\xff\x00\x00\xb1\xff\xb2\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd2\xff\xd1\xff\xcf\xff\xcd\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x4d\xff\x4c\xff\x4b\xff\x4a\xff\x49\xff\x00\x00\x00\x00\x00\x00\xfb\xff\xec\xff\xf7\xff\x00\x00\xf6\xff\xed\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe7\xff\x00\x00\x4f\xff\xf9\xff\xfa\xff\xc1\xff\xc2\xff\x00\x00\x9b\xff\x99\xff\x9a\xff\xc5\xff\x93\xff\x00\x00\xc6\xff\x8c\xff\xc3\xff\x00\x00\xc4\xff\xa3\xff\x00\x00\x9e\xff\x00\x00\xca\xff\xba\xff\xbb\xff\x61\xff\xcb\xff\xcc\xff\xc9\xff\x00\x00\xc8\xff\x00\x00\x4e\xff\xce\xff\xd0\xff\xd3\xff\x00\x00\x00\x00\x00\x00\x00\x00\xd8\xff\x00\x00\x00\x00\xc0\xff\x97\xff\x96\xff\x95\xff\x8e\xff\x00\x00\x00\x00\x7d\xff\x5e\xff\x59\xff\x58\xff\x59\xff\x00\x00\x00\x00\x57\xff\x7a\xff\x56\xff\x79\xff\x00\x00\x80\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x70\xff\x6f\xff\x72\xff\x71\xff\x74\xff\x73\xff\xfc\xff\xe6\xff\x7e\xff\x7f\xff\x82\xff\x83\xff\x81\xff\x84\xff\x85\xff\x7c\xff\x00\x00\x7a\xff\x79\xff\x7b\xff\x5c\xff\x5a\xff\x5d\xff\x59\xff\xc7\xff\x6b\xff\x00\x00\x6e\xff\x00\x00\x00\x00\x00\x00\x50\xff\x52\xff\x00\x00\xd6\xff\xd7\xff\x00\x00\xd4\xff\x00\x00\x88\xff\xdf\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa0\xff\xa4\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf8\xff\xe9\xff\xf5\xff\xe8\xff\xec\xff\xef\xff\xee\xff\xef\xff\x00\x00\x00\x00\xea\xff\xeb\xff\xef\xff\x00\x00\x67\xff\x00\x00\x00\x00\x00\x00\x00\x00\xad\xff\xab\xff\x00\x00\x62\xff\x5f\xff\xaa\xff\xa9\xff\xa8\xff\xa7\xff\x00\x00\x53\xff\x94\xff\x8d\xff\x00\x00\xa5\xff\x00\x00\xa2\xff\x9c\xff\x9f\xff\x9d\xff\xbd\xff\x00\x00\x00\x00\x89\xff\x86\xff\x87\xff\x8b\xff\x00\x00\x00\x00\x51\xff\xd9\xff\x98\xff\x00\x00\x90\xff\x8f\xff\x6d\xff\x00\x00\x5b\xff\x62\xff\x00\x00\x55\xff\x6c\xff\x92\xff\x00\x00\xe0\xff\x00\x00\x00\x00\x8a\xff\xdd\xff\xdb\xff\xdc\xff\x00\x00\xb9\xff\xb8\xff\xbf\xff\xb6\xff\xb4\xff\xb5\xff\x00\x00\xa1\xff\x00\x00\x00\x00\x63\xff\x60\xff\x00\x00\xaf\xff\x00\x00\xe7\xff\xec\xff\x00\x00\x68\xff\x65\xff\xec\xff\x00\x00\xec\xff\x00\x00\x00\x00\xf0\xff\x00\x00\xf1\xff\x00\x00\xae\xff\xac\xff\xa6\xff\x00\x00\x00\x00\xbc\xff\x00\x00\x00\x00\x00\x00\x91\xff\x00\x00\x00\x00\xde\xff\xbe\xff\xb7\xff\x00\x00\xb0\xff\xe7\xff\x66\xff\xe7\xff\x00\x00\xe7\xff\xf3\xff\xf2\xff\x00\x00\xb4\xff\xb5\xff\x00\x00\x00\x00\xd5\xff\xb3\xff\xf4\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x04\x00\x04\x00\x15\x00\x03\x00\x08\x00\x04\x00\x01\x00\x0b\x00\x0c\x00\x0d\x00\x25\x00\x05\x00\x10\x00\x11\x00\x12\x00\x25\x00\x25\x00\x04\x00\x2c\x00\x01\x00\x18\x00\x08\x00\x3b\x00\x3c\x00\x0b\x00\x0c\x00\x0d\x00\x36\x00\x36\x00\x10\x00\x11\x00\x12\x00\x36\x00\x36\x00\x25\x00\x36\x00\x03\x00\x18\x00\x08\x00\x26\x00\x44\x00\x0b\x00\x0c\x00\x0d\x00\x2c\x00\x31\x00\x10\x00\x11\x00\x12\x00\x44\x00\x36\x00\x0b\x00\x0c\x00\x0d\x00\x18\x00\x25\x00\x10\x00\x11\x00\x12\x00\x36\x00\x36\x00\x0f\x00\x31\x00\x43\x00\x18\x00\x45\x00\x44\x00\x36\x00\x0b\x00\x0c\x00\x0d\x00\x0f\x00\x36\x00\x10\x00\x11\x00\x12\x00\x03\x00\x2c\x00\x44\x00\x31\x00\x43\x00\x18\x00\x45\x00\x01\x00\x36\x00\x2b\x00\x04\x00\x26\x00\x27\x00\x31\x00\x36\x00\x14\x00\x01\x00\x03\x00\x36\x00\x04\x00\x36\x00\x43\x00\x2c\x00\x45\x00\x36\x00\x14\x00\x38\x00\x36\x00\x01\x00\x02\x00\x31\x00\x04\x00\x36\x00\x45\x00\x36\x00\x36\x00\x38\x00\x01\x00\x16\x00\x17\x00\x04\x00\x2c\x00\x27\x00\x25\x00\x14\x00\x27\x00\x28\x00\x29\x00\x30\x00\x36\x00\x45\x00\x38\x00\x25\x00\x2f\x00\x27\x00\x28\x00\x29\x00\x36\x00\x2c\x00\x36\x00\x36\x00\x38\x00\x38\x00\x07\x00\x25\x00\x31\x00\x27\x00\x28\x00\x29\x00\x2c\x00\x36\x00\x38\x00\x0a\x00\x25\x00\x2f\x00\x27\x00\x28\x00\x29\x00\x36\x00\x36\x00\x38\x00\x36\x00\x07\x00\x2f\x00\x05\x00\x06\x00\x07\x00\x08\x00\x04\x00\x0a\x00\x36\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x10\x00\x11\x00\x0e\x00\x16\x00\x17\x00\x11\x00\x25\x00\x02\x00\x18\x00\x28\x00\x29\x00\x17\x00\x18\x00\x17\x00\x22\x00\x23\x00\x01\x00\x07\x00\x36\x00\x37\x00\x30\x00\x39\x00\x02\x00\x0a\x00\x09\x00\x24\x00\x25\x00\x0a\x00\x27\x00\x31\x00\x31\x00\x2a\x00\x05\x00\x31\x00\x36\x00\x36\x00\x02\x00\x31\x00\x36\x00\x31\x00\x09\x00\x0a\x00\x36\x00\x36\x00\x36\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x44\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x0a\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x05\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x06\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x08\x00\x14\x00\x0a\x00\x05\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x25\x00\x38\x00\x27\x00\x3a\x00\x07\x00\x2a\x00\x03\x00\x36\x00\x36\x00\x38\x00\x07\x00\x36\x00\x1f\x00\x0e\x00\x21\x00\x30\x00\x11\x00\x36\x00\x36\x00\x37\x00\x08\x00\x39\x00\x0a\x00\x18\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x31\x00\x36\x00\x09\x00\x0a\x00\x33\x00\x36\x00\x09\x00\x0a\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x41\x00\x42\x00\x3d\x00\x44\x00\x09\x00\x0a\x00\x36\x00\x37\x00\x08\x00\x39\x00\x0a\x00\x36\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x2f\x00\x44\x00\x31\x00\x30\x00\x33\x00\x3b\x00\x3c\x00\x36\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x41\x00\x42\x00\x3d\x00\x3e\x00\x3f\x00\x36\x00\x36\x00\x37\x00\x08\x00\x39\x00\x0a\x00\x36\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x2f\x00\x44\x00\x31\x00\x32\x00\x33\x00\x3b\x00\x3c\x00\x36\x00\x0a\x00\x38\x00\x0a\x00\x3a\x00\x34\x00\x35\x00\x36\x00\x3e\x00\x3f\x00\x06\x00\x36\x00\x37\x00\x0a\x00\x39\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x0a\x00\x06\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x0a\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x16\x00\x17\x00\x1d\x00\x36\x00\x13\x00\x1a\x00\x1b\x00\x1c\x00\x22\x00\x23\x00\x2c\x00\x2d\x00\x25\x00\x09\x00\x0a\x00\x00\x00\x01\x00\x02\x00\x03\x00\x1a\x00\x1b\x00\x1c\x00\x07\x00\x31\x00\x13\x00\x0a\x00\x44\x00\x31\x00\x36\x00\x36\x00\x33\x00\x36\x00\x36\x00\x23\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x1b\x00\x1c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x33\x00\x25\x00\x26\x00\x31\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x36\x00\x1c\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x2a\x00\x2b\x00\x2c\x00\x19\x00\x33\x00\x38\x00\x22\x00\x23\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x22\x00\x23\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x33\x00\x22\x00\x23\x00\x31\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x36\x00\x31\x00\x3d\x00\x3e\x00\x3f\x00\x40\x00\x36\x00\x1e\x00\x31\x00\x20\x00\x21\x00\x22\x00\x23\x00\x36\x00\x28\x00\x29\x00\x01\x00\x02\x00\x03\x00\x38\x00\x3c\x00\x2f\x00\x07\x00\x31\x00\x44\x00\x33\x00\x31\x00\x30\x00\x36\x00\x0a\x00\x38\x00\x36\x00\x3a\x00\x29\x00\x02\x00\x03\x00\x3e\x00\x3f\x00\x25\x00\x2f\x00\x09\x00\x31\x00\x02\x00\x33\x00\x22\x00\x23\x00\x36\x00\x3a\x00\x38\x00\x03\x00\x3a\x00\x22\x00\x23\x00\x03\x00\x3e\x00\x3f\x00\x03\x00\x22\x00\x23\x00\x31\x00\x02\x00\x03\x00\x25\x00\x33\x00\x36\x00\x36\x00\x31\x00\x37\x00\x38\x00\x39\x00\x3a\x00\x36\x00\x31\x00\x3d\x00\x02\x00\x03\x00\x3a\x00\x36\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x3a\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x3a\x00\x2e\x00\x2f\x00\x03\x00\x31\x00\x3b\x00\x33\x00\x02\x00\x03\x00\x36\x00\x02\x00\x38\x00\x03\x00\x3a\x00\x3a\x00\x02\x00\x03\x00\x3e\x00\x3f\x00\x40\x00\x2e\x00\x2f\x00\x3a\x00\x31\x00\x01\x00\x33\x00\x02\x00\x03\x00\x36\x00\x03\x00\x38\x00\x02\x00\x3a\x00\x02\x00\x03\x00\x01\x00\x3e\x00\x3f\x00\x40\x00\x2f\x00\x03\x00\x31\x00\x03\x00\x33\x00\x03\x00\x02\x00\x36\x00\x36\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x3a\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x2b\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x3a\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x01\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x36\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x3a\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x36\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x01\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x36\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x01\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x3a\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x3a\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x36\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x03\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x36\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x2c\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x03\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x25\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x36\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x26\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x03\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x03\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x2a\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x03\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x03\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x03\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x26\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x01\x00\x38\x00\x2f\x00\x3a\x00\x31\x00\x03\x00\x33\x00\x3e\x00\x3f\x00\x36\x00\x25\x00\x38\x00\x0b\x00\x3a\x00\x36\x00\x01\x00\x01\x00\x3e\x00\x3f\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x36\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x03\x00\x2e\x00\x36\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2c\x00\x03\x00\x36\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x03\x00\x01\x00\x03\x00\x01\x00\x03\x00\x3a\x00\x36\x00\x24\x00\x3a\x00\x01\x00\x3b\x00\x36\x00\x01\x00\x25\x00\x25\x00\x36\x00\x01\x00\x25\x00\x36\x00\x01\x00\x25\x00\x09\x00\x3b\x00\x01\x00\x3a\x00\x3a\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\xc6\x00\x10\x00\x0c\x01\x1a\x01\x3f\x00\x7c\x00\x14\x01\x40\x00\x17\x00\x18\x00\x61\x00\xcf\x00\x19\x00\x1a\x00\x1b\x00\x68\x00\x61\x00\x3e\x00\xe9\x00\x71\x00\x1c\x00\x3f\x00\xfe\x00\xa3\x00\x40\x00\x17\x00\x18\x00\x16\x00\x16\x00\x19\x00\x1a\x00\x1b\x00\x16\x00\x16\x00\x11\x00\x0d\x01\x1a\x01\x1c\x00\x3f\x00\x7d\x00\x47\x01\x40\x00\x17\x00\x18\x00\x3b\x01\x1d\x00\x19\x00\x1a\x00\x1b\x00\x0e\x01\x1e\x00\xcf\x00\x17\x00\x18\x00\x1c\x00\x68\x00\x19\x00\x1a\x00\x1b\x00\x16\x00\x16\x00\x36\x01\x1d\x00\x41\x00\x1c\x00\x42\x00\x06\x01\x1e\x00\x16\x00\x17\x00\x18\x00\x09\x01\x16\x00\x19\x00\x1a\x00\x1b\x00\xbc\x00\x1b\x01\x34\x01\x1d\x00\x41\x00\x1c\x00\x42\x00\x0f\x00\x1e\x00\x54\x00\x10\x00\x51\x00\x52\x00\x1d\x00\x3c\x01\xb8\x00\xe3\x00\xbc\x00\x1e\x00\x10\x00\x55\x00\x41\x00\xbb\x00\x1f\x00\x0a\x01\x5d\x00\x0b\x01\x53\x00\x0f\x00\xaa\x00\x1d\x00\x10\x00\x16\x00\x1f\x00\x0a\x01\x1e\x00\x0b\x01\x0f\x00\x37\x01\x10\x01\x10\x00\x1c\x01\xe4\x00\x11\x00\x61\x00\x12\x00\x13\x00\x14\x00\x86\x00\x5e\x00\x1f\x00\x5f\x00\x11\x00\x15\x00\x12\x00\x13\x00\x14\x00\x53\x00\xc5\x00\x5e\x00\x16\x00\x5f\x00\xe4\x00\x3e\x01\x11\x00\x11\x01\x12\x00\x13\x00\x14\x00\x5d\x00\x12\x01\xe4\x00\x23\x01\x11\x00\x15\x00\x12\x00\x13\x00\x14\x00\x5e\x00\x16\x00\x5f\x00\x16\x00\x24\x01\x15\x00\x44\x00\x45\x00\x46\x00\x47\x00\x10\x00\x21\x00\x16\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x05\x01\x1a\x00\x42\x01\x2d\x01\x10\x01\xb7\x00\x11\x00\x46\x01\x1c\x00\x13\x00\x14\x00\x38\x01\x1c\x00\x38\x01\x14\x01\x4e\x00\x78\x00\x27\x01\x16\x00\x48\x00\x86\x00\x49\x00\xf6\x00\x1d\x01\xb2\xff\x72\x00\x73\x00\x21\x01\x74\x00\x4f\x00\x11\x01\x75\x00\x22\x01\x1d\x00\x50\x00\x12\x01\xa2\x00\x43\x01\x1e\x00\x11\x01\x49\x01\xc9\x00\x44\x01\x76\x00\x12\x01\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x06\x01\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\xd1\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\xd3\x00\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\xd2\x00\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\x40\x01\x62\x00\x21\x00\xd5\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\xf8\x00\x17\x01\x74\x00\x18\x01\xd6\x00\x75\x00\x49\x00\x5e\x00\xe5\x00\x5f\x00\x4a\x00\xb9\x00\xbd\x00\xb6\x00\xbe\x00\x86\x00\xb7\x00\x76\x00\x16\x00\x48\x00\x3c\x01\x49\x00\x21\x00\x1c\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x1d\x00\x6c\x00\x40\x01\xc9\x00\xdb\x00\x1e\x00\x41\x01\xc9\x00\x80\x00\xff\x00\x82\x00\xdd\x00\x6d\x00\x6e\x00\x84\x00\x6f\x00\x28\x01\xc9\x00\x16\x00\x48\x00\x3e\x01\x49\x00\x21\x00\xf7\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x7e\x00\xf6\x00\x07\x00\x86\x00\x7f\x00\xa2\x00\xa3\x00\x09\x00\x80\x00\x81\x00\x82\x00\x83\x00\xb1\x00\x6e\x00\x84\x00\x0c\x00\x0d\x00\xb0\x00\x16\x00\x48\x00\x1d\x01\x49\x00\x21\x00\xb9\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\xa7\x00\xad\x00\x07\x00\xa8\x00\x08\x00\xa4\x00\xa3\x00\x09\x00\xc7\x00\x0a\x00\xca\x00\x0b\x00\x1e\x01\x1f\x01\x20\x01\x0c\x00\x0d\x00\xcb\x00\x16\x00\x48\x00\x21\x00\x49\x00\x22\x00\x23\x00\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\x29\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x2f\x00\x30\x00\x31\x00\x32\x00\x33\x00\x34\x00\x35\x00\x36\x00\x37\x00\x38\x00\x39\x00\x21\x00\xcd\x00\x22\x00\x08\x01\x24\x00\x25\x00\x26\x00\x27\x00\x28\x00\xd0\x00\x2a\x00\x2b\x00\x2c\x00\x2d\x00\x2e\x00\x0f\x01\x10\x01\x56\x00\x16\x00\x63\x00\x29\x01\xd9\x00\xda\x00\x15\x01\x4e\x00\xb3\x00\xb4\x00\x68\x00\xc8\x00\xc9\x00\x39\x00\x3a\x00\x3b\x00\x3c\x00\xd8\x00\xd9\x00\xda\x00\x3d\x00\x4f\x00\x65\x00\x04\x00\x66\x00\x11\x01\x50\x00\x16\x00\xdb\x00\x6a\x00\x12\x01\xea\x00\x80\x00\xdc\x00\x82\x00\xdd\x00\x2a\x01\xda\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xdb\x00\xa6\x00\x7d\x00\x4f\x00\x80\x00\xdc\x00\x82\x00\xdd\x00\x50\x00\x2b\x01\xde\x00\xdf\x00\xe0\x00\xe1\x00\x8a\x00\x8b\x00\x8c\x00\x4c\x00\xdb\x00\x68\x00\xd7\x00\x4e\x00\x80\x00\xdc\x00\x82\x00\xdd\x00\x4d\x00\x4e\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xdb\x00\xe9\x00\x4e\x00\x4f\x00\x80\x00\xff\x00\x82\x00\xdd\x00\x50\x00\x4f\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\x50\x00\x58\x00\x4f\x00\x59\x00\x5a\x00\x5b\x00\x4e\x00\x50\x00\xf9\x00\xfa\x00\x94\x00\x3b\x00\x3c\x00\x69\x00\x7a\x00\xfb\x00\x3d\x00\x07\x00\x71\x00\x08\x00\x4f\x00\x86\x00\x09\x00\x04\x00\x0a\x00\x50\x00\x0b\x00\x33\x01\x2d\x01\xbc\x00\x0c\x00\x0d\x00\x68\x00\xfb\x00\xb1\xff\x07\x00\x49\x01\x08\x00\xeb\x00\x4e\x00\x09\x00\x06\x00\x0a\x00\x2f\x01\x0b\x00\xbc\x00\x4e\x00\x47\x01\x0c\x00\x0d\x00\x3a\x01\xc0\x00\x4e\x00\x4f\x00\x04\x01\x05\x01\x68\x00\xdb\x00\x50\x00\x16\x00\x4f\x00\x80\x00\xff\x00\x82\x00\xdd\x00\x50\x00\x4f\x00\x00\x01\xe8\x00\xbc\x00\x96\x00\x50\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x06\x00\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\x96\x00\x08\x01\xf1\x00\x26\x01\x07\x00\xff\xff\x08\x00\xee\x00\xef\x00\x09\x00\x27\x01\x0a\x00\xbc\x00\x0b\x00\x96\x00\xf4\x00\xf5\x00\x0c\x00\x0d\x00\xf2\x00\xf0\x00\xf1\x00\x06\x00\x07\x00\x78\x00\x08\x00\xfd\x00\xfe\x00\x09\x00\x2f\x01\x0a\x00\x30\x01\x0b\x00\xaf\x00\xb0\x00\x32\x01\x0c\x00\x0d\x00\xf2\x00\x35\x01\x31\x01\x07\x00\x33\x01\x08\x00\xbc\x00\x02\x01\x09\x00\x16\x00\x0a\x00\x02\x01\x0b\x00\x07\x00\x06\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x17\x01\x0a\x00\x96\x00\x0b\x00\x07\x00\x06\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\xd5\x00\x0a\x00\x97\x00\x0b\x00\x07\x00\x16\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x96\x00\x0a\x00\x98\x00\x0b\x00\x07\x00\xcd\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\xd5\x00\x0a\x00\x99\x00\x0b\x00\x07\x00\x16\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\xe7\x00\x0a\x00\x9a\x00\x0b\x00\x07\x00\x06\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x96\x00\x0a\x00\x9b\x00\x0b\x00\x07\x00\x16\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\xbc\x00\x0a\x00\x9c\x00\x0b\x00\x07\x00\x16\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\xed\x00\x0a\x00\x9d\x00\x0b\x00\x07\x00\xf0\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x68\x00\x0a\x00\x85\x00\x0b\x00\x07\x00\x16\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x7d\x00\x9f\x00\xa6\x00\xa0\x00\x07\x00\x60\xff\x08\x00\x0c\x00\x0d\x00\x09\x00\x63\xff\x0a\x00\xb2\x00\x0b\x00\x07\x00\x8a\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x9f\x00\x0a\x00\x79\x00\x0b\x00\x07\x00\x5f\xff\x08\x00\x0c\x00\x0d\x00\x09\x00\x62\xff\x0a\x00\x85\x00\x0b\x00\x07\x00\x7d\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\xab\x00\x0a\x00\x06\x00\x0b\x00\x07\x00\xac\x00\x08\x00\x0c\x00\x0d\x00\x09\x00\x68\x00\x0a\x00\xad\x00\x0b\x00\x16\x00\x71\x00\xb6\x00\x0c\x00\x0d\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x16\x00\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\xbc\x00\x8e\x00\x16\x00\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\xc0\x00\xc2\x00\x16\x00\x8f\x00\x90\x00\x91\x00\x92\x00\x93\x00\x94\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\xc3\x00\xab\x00\xc4\x00\x78\x00\xc6\x00\x06\x00\xcd\x00\x4c\x00\x06\x00\x58\x00\xff\xff\x16\x00\x65\x00\x68\x00\x61\x00\x16\x00\x6c\x00\x68\x00\x16\x00\x78\x00\x7e\x00\x79\x00\xff\xff\x78\x00\x96\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = Happy_Data_Array.array (3, 182) [
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64),
	(65 , happyReduce_65),
	(66 , happyReduce_66),
	(67 , happyReduce_67),
	(68 , happyReduce_68),
	(69 , happyReduce_69),
	(70 , happyReduce_70),
	(71 , happyReduce_71),
	(72 , happyReduce_72),
	(73 , happyReduce_73),
	(74 , happyReduce_74),
	(75 , happyReduce_75),
	(76 , happyReduce_76),
	(77 , happyReduce_77),
	(78 , happyReduce_78),
	(79 , happyReduce_79),
	(80 , happyReduce_80),
	(81 , happyReduce_81),
	(82 , happyReduce_82),
	(83 , happyReduce_83),
	(84 , happyReduce_84),
	(85 , happyReduce_85),
	(86 , happyReduce_86),
	(87 , happyReduce_87),
	(88 , happyReduce_88),
	(89 , happyReduce_89),
	(90 , happyReduce_90),
	(91 , happyReduce_91),
	(92 , happyReduce_92),
	(93 , happyReduce_93),
	(94 , happyReduce_94),
	(95 , happyReduce_95),
	(96 , happyReduce_96),
	(97 , happyReduce_97),
	(98 , happyReduce_98),
	(99 , happyReduce_99),
	(100 , happyReduce_100),
	(101 , happyReduce_101),
	(102 , happyReduce_102),
	(103 , happyReduce_103),
	(104 , happyReduce_104),
	(105 , happyReduce_105),
	(106 , happyReduce_106),
	(107 , happyReduce_107),
	(108 , happyReduce_108),
	(109 , happyReduce_109),
	(110 , happyReduce_110),
	(111 , happyReduce_111),
	(112 , happyReduce_112),
	(113 , happyReduce_113),
	(114 , happyReduce_114),
	(115 , happyReduce_115),
	(116 , happyReduce_116),
	(117 , happyReduce_117),
	(118 , happyReduce_118),
	(119 , happyReduce_119),
	(120 , happyReduce_120),
	(121 , happyReduce_121),
	(122 , happyReduce_122),
	(123 , happyReduce_123),
	(124 , happyReduce_124),
	(125 , happyReduce_125),
	(126 , happyReduce_126),
	(127 , happyReduce_127),
	(128 , happyReduce_128),
	(129 , happyReduce_129),
	(130 , happyReduce_130),
	(131 , happyReduce_131),
	(132 , happyReduce_132),
	(133 , happyReduce_133),
	(134 , happyReduce_134),
	(135 , happyReduce_135),
	(136 , happyReduce_136),
	(137 , happyReduce_137),
	(138 , happyReduce_138),
	(139 , happyReduce_139),
	(140 , happyReduce_140),
	(141 , happyReduce_141),
	(142 , happyReduce_142),
	(143 , happyReduce_143),
	(144 , happyReduce_144),
	(145 , happyReduce_145),
	(146 , happyReduce_146),
	(147 , happyReduce_147),
	(148 , happyReduce_148),
	(149 , happyReduce_149),
	(150 , happyReduce_150),
	(151 , happyReduce_151),
	(152 , happyReduce_152),
	(153 , happyReduce_153),
	(154 , happyReduce_154),
	(155 , happyReduce_155),
	(156 , happyReduce_156),
	(157 , happyReduce_157),
	(158 , happyReduce_158),
	(159 , happyReduce_159),
	(160 , happyReduce_160),
	(161 , happyReduce_161),
	(162 , happyReduce_162),
	(163 , happyReduce_163),
	(164 , happyReduce_164),
	(165 , happyReduce_165),
	(166 , happyReduce_166),
	(167 , happyReduce_167),
	(168 , happyReduce_168),
	(169 , happyReduce_169),
	(170 , happyReduce_170),
	(171 , happyReduce_171),
	(172 , happyReduce_172),
	(173 , happyReduce_173),
	(174 , happyReduce_174),
	(175 , happyReduce_175),
	(176 , happyReduce_176),
	(177 , happyReduce_177),
	(178 , happyReduce_178),
	(179 , happyReduce_179),
	(180 , happyReduce_180),
	(181 , happyReduce_181),
	(182 , happyReduce_182)
	]

happy_n_terms = 60 :: Int
happy_n_nonterms = 70 :: Int

happyReduce_3 = happySpecReduce_2  0# happyReduction_3
happyReduction_3 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	happyIn6
		 (happy_var_2
	)}

happyReduce_4 = happySpecReduce_1  0# happyReduction_4
happyReduction_4 happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	happyIn6
		 (happy_var_1
	)}

happyReduce_5 = happySpecReduce_2  1# happyReduction_5
happyReduction_5 happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (ProgramFile (MetaInfo { miVersion = Fortran66 })  (reverse happy_var_1) (reverse happy_var_2)
	)}}

happyReduce_6 = happySpecReduce_2  2# happyReduction_6
happyReduction_6 happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut9 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 (([ ], happy_var_2) : happy_var_1
	)}}

happyReduce_7 = happySpecReduce_3  2# happyReduction_7
happyReduction_7 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	case happyOut10 happy_x_3 of { happy_var_3 -> 
	happyIn8
		 ((reverse happy_var_2, happy_var_3) : happy_var_1
	)}}}

happyReduce_8 = happySpecReduce_1  2# happyReduction_8
happyReduction_8 happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 ([ ([ ], happy_var_1) ]
	)}

happyReduce_9 = happySpecReduce_2  2# happyReduction_9
happyReduction_9 happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOut10 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 ([ (reverse happy_var_1, happy_var_2) ]
	)}}

happyReduce_10 = happySpecReduce_3  3# happyReduction_10
happyReduction_10 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn9
		 (let blocks = reverse happy_var_1
    in PUMain () (getTransSpan happy_var_1 happy_var_2) Nothing blocks Nothing
	)}}

happyReduce_11 = happyReduce 8# 4# happyReduction_11
happyReduction_11 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	case happyOut11 happy_x_4 of { happy_var_4 -> 
	case happyOut13 happy_x_6 of { happy_var_6 -> 
	case happyOutTok happy_x_7 of { happy_var_7 -> 
	happyIn10
		 (PUFunction () (getTransSpan happy_var_1 happy_var_7) (Just happy_var_1) False happy_var_3 happy_var_4 Nothing (reverse happy_var_6) Nothing
	) `HappyStk` happyRest}}}}}

happyReduce_12 = happyReduce 7# 4# happyReduction_12
happyReduction_12 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_2 of { happy_var_2 -> 
	case happyOut11 happy_x_3 of { happy_var_3 -> 
	case happyOut13 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_6 of { happy_var_6 -> 
	happyIn10
		 (PUFunction () (getTransSpan happy_var_1 happy_var_6) Nothing False happy_var_2 happy_var_3 Nothing (reverse happy_var_5) Nothing
	) `HappyStk` happyRest}}}}}

happyReduce_13 = happyReduce 7# 4# happyReduction_13
happyReduction_13 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_2 of { happy_var_2 -> 
	case happyOut11 happy_x_3 of { happy_var_3 -> 
	case happyOut13 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_6 of { happy_var_6 -> 
	happyIn10
		 (PUSubroutine () (getTransSpan happy_var_1 happy_var_6) False happy_var_2 happy_var_3 (reverse happy_var_5) Nothing
	) `HappyStk` happyRest}}}}}

happyReduce_14 = happyReduce 5# 4# happyReduction_14
happyReduction_14 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn10
		 (PUBlockData () (getTransSpan happy_var_1 happy_var_4) Nothing (reverse happy_var_3)
	) `HappyStk` happyRest}}}

happyReduce_15 = happySpecReduce_3  5# happyReduction_15
happyReduction_15 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut58 happy_x_2 of { happy_var_2 -> 
	happyIn11
		 (happy_var_2
	)}

happyReduce_16 = happySpecReduce_0  5# happyReduction_16
happyReduction_16  =  happyIn11
		 (Nothing
	)

happyReduce_17 = happySpecReduce_1  6# happyReduction_17
happyReduction_17 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn12
		 (let (TId _ name) = happy_var_1 in name
	)}

happyReduce_18 = happySpecReduce_2  7# happyReduction_18
happyReduction_18 happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOut14 happy_x_2 of { happy_var_2 -> 
	happyIn13
		 (happy_var_2 : happy_var_1
	)}}

happyReduce_19 = happySpecReduce_0  7# happyReduction_19
happyReduction_19  =  happyIn13
		 ([ ]
	)

happyReduce_20 = happySpecReduce_3  8# happyReduction_20
happyReduction_20 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut73 happy_x_1 of { happy_var_1 -> 
	case happyOut17 happy_x_2 of { happy_var_2 -> 
	happyIn14
		 (BlStatement () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) happy_var_2
	)}}

happyReduce_21 = happySpecReduce_2  8# happyReduction_21
happyReduction_21 happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (BlStatement () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_22 = happySpecReduce_2  8# happyReduction_22
happyReduction_22 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (let (TComment s c) = happy_var_1 in BlComment () s c
	)}

happyReduce_23 = happySpecReduce_1  9# happyReduction_23
happyReduction_23 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn15
		 (Just happy_var_1
	)}

happyReduce_24 = happySpecReduce_0  9# happyReduction_24
happyReduction_24  =  happyIn15
		 (Nothing
	)

happyReduce_25 = happySpecReduce_2  10# happyReduction_25
happyReduction_25 happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (happy_var_1
	)}

happyReduce_26 = happySpecReduce_1  10# happyReduction_26
happyReduction_26 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (happy_var_1
	)}

happyReduce_27 = happySpecReduce_1  11# happyReduction_27
happyReduction_27 happy_x_1
	 =  case happyOut18 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_28 = happySpecReduce_1  11# happyReduction_28
happyReduction_28 happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_29 = happySpecReduce_1  11# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_30 = happySpecReduce_1  11# happyReduction_30
happyReduction_30 happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_31 = happyReduce 5# 12# happyReduction_31
happyReduction_31 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	case happyOut22 happy_x_5 of { happy_var_5 -> 
	happyIn18
		 (StIfLogical () (getTransSpan happy_var_1 happy_var_5) happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_32 = happySpecReduce_3  13# happyReduction_32
happyReduction_32 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_2 of { happy_var_2 -> 
	case happyOut20 happy_x_3 of { happy_var_3 -> 
	happyIn19
		 (StDo () (getTransSpan happy_var_1 happy_var_3) Nothing (Just happy_var_2) (Just happy_var_3)
	)}}}

happyReduce_33 = happyReduce 5# 14# happyReduction_33
happyReduction_33 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut21 happy_x_3 of { happy_var_3 -> 
	case happyOut21 happy_x_5 of { happy_var_5 -> 
	happyIn20
		 (DoSpecification () (getTransSpan happy_var_1 happy_var_5) happy_var_1 happy_var_3 (Just happy_var_5)
	) `HappyStk` happyRest}}}

happyReduce_34 = happySpecReduce_3  14# happyReduction_34
happyReduction_34 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	case happyOut21 happy_x_3 of { happy_var_3 -> 
	happyIn20
		 (DoSpecification () (getTransSpan happy_var_1 happy_var_3) happy_var_1 happy_var_3 Nothing
	)}}

happyReduce_35 = happySpecReduce_1  15# happyReduction_35
happyReduction_35 happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	happyIn21
		 (happy_var_1
	)}

happyReduce_36 = happySpecReduce_1  15# happyReduction_36
happyReduction_36 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn21
		 (happy_var_1
	)}

happyReduce_37 = happySpecReduce_1  16# happyReduction_37
happyReduction_37 happy_x_1
	 =  case happyOut23 happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (happy_var_1
	)}

happyReduce_38 = happyReduce 4# 16# happyReduction_38
happyReduction_38 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_2 of { happy_var_2 -> 
	case happyOut60 happy_x_4 of { happy_var_4 -> 
	happyIn22
		 (StLabelAssign () (getTransSpan happy_var_1 happy_var_4) happy_var_2 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_39 = happySpecReduce_2  16# happyReduction_39
happyReduction_39 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StGotoUnconditional () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_40 = happySpecReduce_3  16# happyReduction_40
happyReduction_40 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_2 of { happy_var_2 -> 
	case happyOut71 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (StGotoAssigned () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_3
	)}}}

happyReduce_41 = happySpecReduce_3  16# happyReduction_41
happyReduction_41 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut71 happy_x_2 of { happy_var_2 -> 
	case happyOut60 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (StGotoComputed () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_3
	)}}}

happyReduce_42 = happyReduce 9# 16# happyReduction_42
happyReduction_42 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	case happyOut74 happy_x_5 of { happy_var_5 -> 
	case happyOut74 happy_x_7 of { happy_var_7 -> 
	case happyOut74 happy_x_9 of { happy_var_9 -> 
	happyIn22
		 (StIfArithmetic () (getTransSpan happy_var_1 happy_var_9) happy_var_3 happy_var_5 happy_var_7 happy_var_9
	) `HappyStk` happyRest}}}}}

happyReduce_43 = happySpecReduce_3  16# happyReduction_43
happyReduction_43 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_2 of { happy_var_2 -> 
	case happyOut50 happy_x_3 of { happy_var_3 -> 
	happyIn22
		 (StCall () (getTransSpan happy_var_1 happy_var_3) happy_var_2 (Just happy_var_3)
	)}}}

happyReduce_44 = happySpecReduce_2  16# happyReduction_44
happyReduction_44 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StCall () (getTransSpan happy_var_1 happy_var_2) happy_var_2 Nothing
	)}}

happyReduce_45 = happySpecReduce_1  16# happyReduction_45
happyReduction_45 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StReturn () (getSpan happy_var_1) Nothing
	)}

happyReduce_46 = happySpecReduce_1  16# happyReduction_46
happyReduction_46 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StContinue () $ getSpan happy_var_1
	)}

happyReduce_47 = happySpecReduce_2  16# happyReduction_47
happyReduction_47 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut62 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StStop () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)}}

happyReduce_48 = happySpecReduce_1  16# happyReduction_48
happyReduction_48 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StStop () (getSpan happy_var_1) Nothing
	)}

happyReduce_49 = happySpecReduce_2  16# happyReduction_49
happyReduction_49 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut62 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StPause () (getTransSpan happy_var_1 happy_var_2) $ Just happy_var_2
	)}}

happyReduce_50 = happySpecReduce_1  16# happyReduction_50
happyReduction_50 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (StPause () (getSpan happy_var_1) Nothing
	)}

happyReduce_51 = happySpecReduce_2  16# happyReduction_51
happyReduction_51 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StRewind2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_52 = happySpecReduce_2  16# happyReduction_52
happyReduction_52 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StBackspace2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_53 = happySpecReduce_2  16# happyReduction_53
happyReduction_53 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (StEndfile2 () (getTransSpan happy_var_1 happy_var_2) happy_var_2
	)}}

happyReduce_54 = happySpecReduce_2  16# happyReduction_54
happyReduction_54 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (let (cilist, iolist) = happy_var_2 in StWrite () (getTransSpan happy_var_1 happy_var_2) cilist iolist
	)}}

happyReduce_55 = happySpecReduce_2  16# happyReduction_55
happyReduction_55 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn22
		 (let (cilist, iolist) = happy_var_2 in StRead () (getTransSpan happy_var_1 happy_var_2) cilist iolist
	)}}

happyReduce_56 = happySpecReduce_3  17# happyReduction_56
happyReduction_56 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn23
		 (StExpressionAssign () (getTransSpan happy_var_1 happy_var_3) happy_var_1 happy_var_3
	)}}

happyReduce_57 = happySpecReduce_2  18# happyReduction_57
happyReduction_57 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut49 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (StExternal () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_58 = happySpecReduce_2  18# happyReduction_58
happyReduction_58 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut44 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (StDimension () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_59 = happySpecReduce_2  18# happyReduction_59
happyReduction_59 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut36 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (StCommon () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_60 = happySpecReduce_2  18# happyReduction_60
happyReduction_60 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut35 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (StEquivalence () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_61 = happySpecReduce_2  18# happyReduction_61
happyReduction_61 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut31 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (StData () (getTransSpan happy_var_1 happy_var_2) (aReverse happy_var_2)
	)}}

happyReduce_62 = happySpecReduce_2  18# happyReduction_62
happyReduction_62 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (let TBlob s blob = happy_var_2 in StFormatBogus () (getTransSpan happy_var_1 s) blob
	)}}

happyReduce_63 = happySpecReduce_2  18# happyReduction_63
happyReduction_63 happy_x_2
	happy_x_1
	 =  case happyOut75 happy_x_1 of { happy_var_1 -> 
	case happyOut42 happy_x_2 of { happy_var_2 -> 
	happyIn24
		 (StDeclaration () (getTransSpan happy_var_1 happy_var_2) happy_var_1 Nothing (aReverse happy_var_2)
	)}}

happyReduce_64 = happyReduce 4# 19# happyReduction_64
happyReduction_64 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut28 happy_x_4 of { happy_var_4 -> 
	happyIn25
		 ((AList () (getSpan happy_var_2) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2 ], Just (aReverse happy_var_4))
	) `HappyStk` happyRest}}

happyReduce_65 = happyReduce 6# 19# happyReduction_65
happyReduction_65 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut27 happy_x_4 of { happy_var_4 -> 
	case happyOut28 happy_x_6 of { happy_var_6 -> 
	happyIn25
		 ((AList () (getTransSpan happy_var_2 happy_var_4) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2, ControlPair () (getSpan happy_var_4) Nothing happy_var_4 ], Just (aReverse happy_var_6))
	) `HappyStk` happyRest}}}

happyReduce_66 = happySpecReduce_3  19# happyReduction_66
happyReduction_66 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn25
		 ((AList () (getSpan happy_var_2) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2 ], Nothing)
	)}

happyReduce_67 = happyReduce 5# 19# happyReduction_67
happyReduction_67 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut27 happy_x_4 of { happy_var_4 -> 
	happyIn25
		 ((AList () (getTransSpan happy_var_2 happy_var_4) [ ControlPair () (getSpan happy_var_2) Nothing happy_var_2, ControlPair () (getSpan happy_var_4) Nothing happy_var_4 ], Nothing)
	) `HappyStk` happyRest}}

happyReduce_68 = happySpecReduce_1  20# happyReduction_68
happyReduction_68 happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 (happy_var_1
	)}

happyReduce_69 = happySpecReduce_1  20# happyReduction_69
happyReduction_69 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 (happy_var_1
	)}

happyReduce_70 = happySpecReduce_1  21# happyReduction_70
happyReduction_70 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn27
		 (happy_var_1
	)}

happyReduce_71 = happySpecReduce_1  21# happyReduction_71
happyReduction_71 happy_x_1
	 =  case happyOut74 happy_x_1 of { happy_var_1 -> 
	happyIn27
		 (happy_var_1
	)}

happyReduce_72 = happySpecReduce_3  22# happyReduction_72
happyReduction_72 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut28 happy_x_1 of { happy_var_1 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	happyIn28
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_73 = happySpecReduce_1  22# happyReduction_73
happyReduction_73 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn28
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_74 = happySpecReduce_1  23# happyReduction_74
happyReduction_74 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_75 = happySpecReduce_1  23# happyReduction_75
happyReduction_75 happy_x_1
	 =  case happyOut55 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_76 = happyReduce 5# 23# happyReduction_76
happyReduction_76 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut28 happy_x_2 of { happy_var_2 -> 
	case happyOut20 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn29
		 (ExpImpliedDo () (getTransSpan happy_var_1 happy_var_5) happy_var_2 happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_77 = happySpecReduce_1  24# happyReduction_77
happyReduction_77 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (happy_var_1
	)}

happyReduce_78 = happySpecReduce_1  24# happyReduction_78
happyReduction_78 happy_x_1
	 =  case happyOut55 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (happy_var_1
	)}

happyReduce_79 = happyReduce 6# 25# happyReduction_79
happyReduction_79 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_3 of { happy_var_3 -> 
	case happyOut32 happy_x_5 of { happy_var_5 -> 
	case happyOutTok happy_x_6 of { happy_var_6 -> 
	happyIn31
		 (setSpan (getTransSpan happy_var_1 happy_var_6) $ (DataGroup () (getTransSpan happy_var_3 happy_var_6) (aReverse happy_var_3) (aReverse happy_var_5)) `aCons` happy_var_1
	) `HappyStk` happyRest}}}}

happyReduce_80 = happyReduce 4# 25# happyReduction_80
happyReduction_80 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut40 happy_x_1 of { happy_var_1 -> 
	case happyOut32 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn31
		 (AList () (getTransSpan happy_var_1 happy_var_4) [ DataGroup () (getTransSpan happy_var_1 happy_var_4) (aReverse happy_var_1) (aReverse happy_var_3) ]
	) `HappyStk` happyRest}}}

happyReduce_81 = happySpecReduce_3  26# happyReduction_81
happyReduction_81 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut32 happy_x_1 of { happy_var_1 -> 
	case happyOut33 happy_x_3 of { happy_var_3 -> 
	happyIn32
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_82 = happySpecReduce_1  26# happyReduction_82
happyReduction_82 happy_x_1
	 =  case happyOut33 happy_x_1 of { happy_var_1 -> 
	happyIn32
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_83 = happySpecReduce_3  27# happyReduction_83
happyReduction_83 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	case happyOut34 happy_x_3 of { happy_var_3 -> 
	happyIn33
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_84 = happySpecReduce_1  27# happyReduction_84
happyReduction_84 happy_x_1
	 =  case happyOut34 happy_x_1 of { happy_var_1 -> 
	happyIn33
		 (happy_var_1
	)}

happyReduce_85 = happySpecReduce_1  28# happyReduction_85
happyReduction_85 happy_x_1
	 =  case happyOut67 happy_x_1 of { happy_var_1 -> 
	happyIn34
		 (happy_var_1
	)}

happyReduce_86 = happySpecReduce_1  28# happyReduction_86
happyReduction_86 happy_x_1
	 =  case happyOut68 happy_x_1 of { happy_var_1 -> 
	happyIn34
		 (happy_var_1
	)}

happyReduce_87 = happySpecReduce_1  28# happyReduction_87
happyReduction_87 happy_x_1
	 =  case happyOut69 happy_x_1 of { happy_var_1 -> 
	happyIn34
		 (happy_var_1
	)}

happyReduce_88 = happySpecReduce_1  28# happyReduction_88
happyReduction_88 happy_x_1
	 =  case happyOut70 happy_x_1 of { happy_var_1 -> 
	happyIn34
		 (happy_var_1
	)}

happyReduce_89 = happyReduce 5# 29# happyReduction_89
happyReduction_89 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut35 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	case happyOut40 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn35
		 (setSpan (getTransSpan happy_var_1 happy_var_5) $ (setSpan (getTransSpan happy_var_3 happy_var_5) $ aReverse happy_var_4) `aCons` happy_var_1
	) `HappyStk` happyRest}}}}

happyReduce_90 = happySpecReduce_3  29# happyReduction_90
happyReduction_90 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn35
		 (let s = (getTransSpan happy_var_1 happy_var_3) in AList () s [ setSpan s $ aReverse happy_var_2 ]
	)}}}

happyReduce_91 = happySpecReduce_2  30# happyReduction_91
happyReduction_91 happy_x_2
	happy_x_1
	 =  case happyOut36 happy_x_1 of { happy_var_1 -> 
	case happyOut37 happy_x_2 of { happy_var_2 -> 
	happyIn36
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ happy_var_2 `aCons` happy_var_1
	)}}

happyReduce_92 = happySpecReduce_1  30# happyReduction_92
happyReduction_92 happy_x_1
	 =  case happyOut38 happy_x_1 of { happy_var_1 -> 
	happyIn36
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_93 = happySpecReduce_2  31# happyReduction_93
happyReduction_93 happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_2 of { happy_var_2 -> 
	happyIn37
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) $ aReverse happy_var_2
	)}}

happyReduce_94 = happySpecReduce_3  31# happyReduction_94
happyReduction_94 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_3 of { happy_var_3 -> 
	happyIn37
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_3) Nothing $ aReverse happy_var_3
	)}}

happyReduce_95 = happySpecReduce_2  32# happyReduction_95
happyReduction_95 happy_x_2
	happy_x_1
	 =  case happyOut39 happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_2 of { happy_var_2 -> 
	happyIn38
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_2) (Just happy_var_1) $ aReverse happy_var_2
	)}}

happyReduce_96 = happySpecReduce_3  32# happyReduction_96
happyReduction_96 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut40 happy_x_3 of { happy_var_3 -> 
	happyIn38
		 (CommonGroup () (getTransSpan happy_var_1 happy_var_3) Nothing $ aReverse happy_var_3
	)}}

happyReduce_97 = happySpecReduce_1  32# happyReduction_97
happyReduction_97 happy_x_1
	 =  case happyOut40 happy_x_1 of { happy_var_1 -> 
	happyIn38
		 (CommonGroup () (getSpan happy_var_1) Nothing $ aReverse happy_var_1
	)}

happyReduce_98 = happySpecReduce_3  33# happyReduction_98
happyReduction_98 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn39
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_99 = happySpecReduce_3  34# happyReduction_99
happyReduction_99 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut40 happy_x_1 of { happy_var_1 -> 
	case happyOut41 happy_x_3 of { happy_var_3 -> 
	happyIn40
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_100 = happySpecReduce_1  34# happyReduction_100
happyReduction_100 happy_x_1
	 =  case happyOut41 happy_x_1 of { happy_var_1 -> 
	happyIn40
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_101 = happySpecReduce_1  35# happyReduction_101
happyReduction_101 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn41
		 (happy_var_1
	)}

happyReduce_102 = happySpecReduce_1  35# happyReduction_102
happyReduction_102 happy_x_1
	 =  case happyOut55 happy_x_1 of { happy_var_1 -> 
	happyIn41
		 (happy_var_1
	)}

happyReduce_103 = happySpecReduce_3  36# happyReduction_103
happyReduction_103 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut42 happy_x_1 of { happy_var_1 -> 
	case happyOut43 happy_x_3 of { happy_var_3 -> 
	happyIn42
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_104 = happySpecReduce_1  36# happyReduction_104
happyReduction_104 happy_x_1
	 =  case happyOut43 happy_x_1 of { happy_var_1 -> 
	happyIn42
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_105 = happySpecReduce_1  37# happyReduction_105
happyReduction_105 happy_x_1
	 =  case happyOut45 happy_x_1 of { happy_var_1 -> 
	happyIn43
		 (happy_var_1
	)}

happyReduce_106 = happySpecReduce_1  37# happyReduction_106
happyReduction_106 happy_x_1
	 =  case happyOut48 happy_x_1 of { happy_var_1 -> 
	happyIn43
		 (happy_var_1
	)}

happyReduce_107 = happySpecReduce_3  38# happyReduction_107
happyReduction_107 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut44 happy_x_1 of { happy_var_1 -> 
	case happyOut45 happy_x_3 of { happy_var_3 -> 
	happyIn44
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_108 = happySpecReduce_1  38# happyReduction_108
happyReduction_108 happy_x_1
	 =  case happyOut45 happy_x_1 of { happy_var_1 -> 
	happyIn44
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_109 = happyReduce 4# 39# happyReduction_109
happyReduction_109 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut60 happy_x_1 of { happy_var_1 -> 
	case happyOut46 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn45
		 (DeclArray () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (aReverse happy_var_3) Nothing Nothing
	) `HappyStk` happyRest}}}

happyReduce_110 = happySpecReduce_3  40# happyReduction_110
happyReduction_110 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut46 happy_x_1 of { happy_var_1 -> 
	case happyOut47 happy_x_3 of { happy_var_3 -> 
	happyIn46
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_111 = happySpecReduce_1  40# happyReduction_111
happyReduction_111 happy_x_1
	 =  case happyOut47 happy_x_1 of { happy_var_1 -> 
	happyIn46
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_112 = happySpecReduce_1  41# happyReduction_112
happyReduction_112 happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	happyIn47
		 (DimensionDeclarator () (getSpan happy_var_1) Nothing (Just happy_var_1)
	)}

happyReduce_113 = happySpecReduce_1  42# happyReduction_113
happyReduction_113 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn48
		 (DeclVariable () (getSpan happy_var_1) happy_var_1 Nothing Nothing
	)}

happyReduce_114 = happySpecReduce_3  43# happyReduction_114
happyReduction_114 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut49 happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_3 of { happy_var_3 -> 
	happyIn49
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_115 = happySpecReduce_1  43# happyReduction_115
happyReduction_115 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn49
		 (AList () (getSpan happy_var_1) [ happy_var_1 ]
	)}

happyReduce_116 = happySpecReduce_2  44# happyReduction_116
happyReduction_116 happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn50
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)}}

happyReduce_117 = happySpecReduce_3  45# happyReduction_117
happyReduction_117 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut51 happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_3 of { happy_var_3 -> 
	happyIn51
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_118 = happySpecReduce_2  45# happyReduction_118
happyReduction_118 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut52 happy_x_2 of { happy_var_2 -> 
	happyIn51
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)}}

happyReduce_119 = happySpecReduce_1  45# happyReduction_119
happyReduction_119 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn51
		 (AList () (getSpan happy_var_1) [ ]
	)}

happyReduce_120 = happySpecReduce_1  46# happyReduction_120
happyReduction_120 happy_x_1
	 =  case happyOut70 happy_x_1 of { happy_var_1 -> 
	happyIn52
		 (Argument () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_121 = happySpecReduce_1  46# happyReduction_121
happyReduction_121 happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	happyIn52
		 (Argument () (getSpan happy_var_1) Nothing happy_var_1
	)}

happyReduce_122 = happySpecReduce_3  47# happyReduction_122
happyReduction_122 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Addition happy_var_1 happy_var_3
	)}}

happyReduce_123 = happySpecReduce_3  47# happyReduction_123
happyReduction_123 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Subtraction happy_var_1 happy_var_3
	)}}

happyReduce_124 = happySpecReduce_3  47# happyReduction_124
happyReduction_124 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Multiplication happy_var_1 happy_var_3
	)}}

happyReduce_125 = happySpecReduce_3  47# happyReduction_125
happyReduction_125 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Division happy_var_1 happy_var_3
	)}}

happyReduce_126 = happySpecReduce_3  47# happyReduction_126
happyReduction_126 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Exponentiation happy_var_1 happy_var_3
	)}}

happyReduce_127 = happySpecReduce_2  47# happyReduction_127
happyReduction_127 happy_x_2
	happy_x_1
	 =  case happyOut57 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_2 of { happy_var_2 -> 
	happyIn53
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_128 = happySpecReduce_3  47# happyReduction_128
happyReduction_128 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) Or happy_var_1 happy_var_3
	)}}

happyReduce_129 = happySpecReduce_3  47# happyReduction_129
happyReduction_129 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) And happy_var_1 happy_var_3
	)}}

happyReduce_130 = happySpecReduce_2  47# happyReduction_130
happyReduction_130 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_2 of { happy_var_2 -> 
	happyIn53
		 (ExpUnary () (getTransSpan happy_var_1 happy_var_2) Not happy_var_2
	)}}

happyReduce_131 = happySpecReduce_3  47# happyReduction_131
happyReduction_131 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	case happyOut54 happy_x_2 of { happy_var_2 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (ExpBinary () (getTransSpan happy_var_1 happy_var_3) happy_var_2 happy_var_1 happy_var_3
	)}}}

happyReduce_132 = happySpecReduce_3  47# happyReduction_132
happyReduction_132 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn53
		 (setSpan (getTransSpan happy_var_1 happy_var_3) happy_var_2
	)}}}

happyReduce_133 = happySpecReduce_1  47# happyReduction_133
happyReduction_133 happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_134 = happySpecReduce_1  47# happyReduction_134
happyReduction_134 happy_x_1
	 =  case happyOut64 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_135 = happySpecReduce_1  47# happyReduction_135
happyReduction_135 happy_x_1
	 =  case happyOut68 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_136 = happySpecReduce_1  47# happyReduction_136
happyReduction_136 happy_x_1
	 =  case happyOut69 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_137 = happySpecReduce_1  47# happyReduction_137
happyReduction_137 happy_x_1
	 =  case happyOut55 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_138 = happySpecReduce_1  47# happyReduction_138
happyReduction_138 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn53
		 (happy_var_1
	)}

happyReduce_139 = happySpecReduce_1  48# happyReduction_139
happyReduction_139 happy_x_1
	 =  happyIn54
		 (EQ
	)

happyReduce_140 = happySpecReduce_1  48# happyReduction_140
happyReduction_140 happy_x_1
	 =  happyIn54
		 (NE
	)

happyReduce_141 = happySpecReduce_1  48# happyReduction_141
happyReduction_141 happy_x_1
	 =  happyIn54
		 (GT
	)

happyReduce_142 = happySpecReduce_1  48# happyReduction_142
happyReduction_142 happy_x_1
	 =  happyIn54
		 (GTE
	)

happyReduce_143 = happySpecReduce_1  48# happyReduction_143
happyReduction_143 happy_x_1
	 =  happyIn54
		 (LT
	)

happyReduce_144 = happySpecReduce_1  48# happyReduction_144
happyReduction_144 happy_x_1
	 =  happyIn54
		 (LTE
	)

happyReduce_145 = happySpecReduce_3  49# happyReduction_145
happyReduction_145 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	happyIn55
		 (ExpFunctionCall () (getTransSpan happy_var_1 happy_var_3) happy_var_1 Nothing
	)}}

happyReduce_146 = happyReduce 4# 49# happyReduction_146
happyReduction_146 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut60 happy_x_1 of { happy_var_1 -> 
	case happyOut56 happy_x_3 of { happy_var_3 -> 
	case happyOutTok happy_x_4 of { happy_var_4 -> 
	happyIn55
		 (ExpSubscript () (getTransSpan happy_var_1 happy_var_4) happy_var_1 (fromReverseList happy_var_3)
	) `HappyStk` happyRest}}}

happyReduce_147 = happySpecReduce_3  50# happyReduction_147
happyReduction_147 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut56 happy_x_1 of { happy_var_1 -> 
	case happyOut53 happy_x_3 of { happy_var_3 -> 
	happyIn56
		 (IxSingle () (getSpan happy_var_3) Nothing happy_var_3 : happy_var_1
	)}}

happyReduce_148 = happySpecReduce_1  50# happyReduction_148
happyReduction_148 happy_x_1
	 =  case happyOut53 happy_x_1 of { happy_var_1 -> 
	happyIn56
		 ([ IxSingle () (getSpan happy_var_1) Nothing happy_var_1 ]
	)}

happyReduce_149 = happySpecReduce_1  51# happyReduction_149
happyReduction_149 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn57
		 ((getSpan happy_var_1, Minus)
	)}

happyReduce_150 = happySpecReduce_1  51# happyReduction_150
happyReduction_150 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn57
		 ((getSpan happy_var_1, Plus)
	)}

happyReduce_151 = happySpecReduce_1  52# happyReduction_151
happyReduction_151 happy_x_1
	 =  case happyOut59 happy_x_1 of { happy_var_1 -> 
	happyIn58
		 (Just $ fromReverseList happy_var_1
	)}

happyReduce_152 = happySpecReduce_0  52# happyReduction_152
happyReduction_152  =  happyIn58
		 (Nothing
	)

happyReduce_153 = happySpecReduce_3  53# happyReduction_153
happyReduction_153 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut59 happy_x_1 of { happy_var_1 -> 
	case happyOut60 happy_x_3 of { happy_var_3 -> 
	happyIn59
		 (happy_var_3 : happy_var_1
	)}}

happyReduce_154 = happySpecReduce_1  53# happyReduction_154
happyReduction_154 happy_x_1
	 =  case happyOut60 happy_x_1 of { happy_var_1 -> 
	happyIn59
		 ([ happy_var_1 ]
	)}

happyReduce_155 = happySpecReduce_1  54# happyReduction_155
happyReduction_155 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn60
		 (ExpValue () (getSpan happy_var_1) $ let (TId _ s) = happy_var_1 in ValVariable s
	)}

happyReduce_156 = happySpecReduce_2  55# happyReduction_156
happyReduction_156 happy_x_2
	happy_x_1
	 =  case happyOut57 happy_x_1 of { happy_var_1 -> 
	case happyOut62 happy_x_2 of { happy_var_2 -> 
	happyIn61
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_157 = happySpecReduce_1  55# happyReduction_157
happyReduction_157 happy_x_1
	 =  case happyOut62 happy_x_1 of { happy_var_1 -> 
	happyIn61
		 (happy_var_1
	)}

happyReduce_158 = happySpecReduce_1  56# happyReduction_158
happyReduction_158 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn62
		 (ExpValue () (getSpan happy_var_1) $ let (TInt _ i) = happy_var_1 in ValInteger i
	)}

happyReduce_159 = happySpecReduce_2  57# happyReduction_159
happyReduction_159 happy_x_2
	happy_x_1
	 =  case happyOut57 happy_x_1 of { happy_var_1 -> 
	case happyOut64 happy_x_2 of { happy_var_2 -> 
	happyIn63
		 (ExpUnary () (getTransSpan (fst happy_var_1) happy_var_2) (snd happy_var_1) happy_var_2
	)}}

happyReduce_160 = happySpecReduce_1  57# happyReduction_160
happyReduction_160 happy_x_1
	 =  case happyOut64 happy_x_1 of { happy_var_1 -> 
	happyIn63
		 (happy_var_1
	)}

happyReduce_161 = happySpecReduce_2  58# happyReduction_161
happyReduction_161 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut66 happy_x_2 of { happy_var_2 -> 
	happyIn64
		 (makeReal (Just happy_var_1) Nothing Nothing (Just happy_var_2)
	)}}

happyReduce_162 = happySpecReduce_3  58# happyReduction_162
happyReduction_162 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	case happyOut65 happy_x_3 of { happy_var_3 -> 
	happyIn64
		 (makeReal (Just happy_var_1) (Just happy_var_2) Nothing happy_var_3
	)}}}

happyReduce_163 = happySpecReduce_3  58# happyReduction_163
happyReduction_163 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	case happyOut65 happy_x_3 of { happy_var_3 -> 
	happyIn64
		 (makeReal Nothing (Just happy_var_1) (Just happy_var_2) happy_var_3
	)}}}

happyReduce_164 = happyReduce 4# 58# happyReduction_164
happyReduction_164 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { happy_var_3 -> 
	case happyOut65 happy_x_4 of { happy_var_4 -> 
	happyIn64
		 (makeReal (Just happy_var_1) (Just happy_var_2) (Just happy_var_3) happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_165 = happySpecReduce_1  59# happyReduction_165
happyReduction_165 happy_x_1
	 =  case happyOut66 happy_x_1 of { happy_var_1 -> 
	happyIn65
		 (Just happy_var_1
	)}

happyReduce_166 = happySpecReduce_0  59# happyReduction_166
happyReduction_166  =  happyIn65
		 (Nothing
	)

happyReduce_167 = happySpecReduce_1  60# happyReduction_167
happyReduction_167 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn66
		 (let (TExponent s exp) = happy_var_1 in (s, exp)
	)}

happyReduce_168 = happySpecReduce_1  61# happyReduction_168
happyReduction_168 happy_x_1
	 =  case happyOut61 happy_x_1 of { happy_var_1 -> 
	happyIn67
		 (happy_var_1
	)}

happyReduce_169 = happySpecReduce_1  61# happyReduction_169
happyReduction_169 happy_x_1
	 =  case happyOut63 happy_x_1 of { happy_var_1 -> 
	happyIn67
		 (happy_var_1
	)}

happyReduce_170 = happyReduce 5# 62# happyReduction_170
happyReduction_170 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut67 happy_x_2 of { happy_var_2 -> 
	case happyOut67 happy_x_4 of { happy_var_4 -> 
	case happyOutTok happy_x_5 of { happy_var_5 -> 
	happyIn68
		 (ExpValue () (getTransSpan happy_var_1 happy_var_5) (ValComplex happy_var_2 happy_var_4)
	) `HappyStk` happyRest}}}}

happyReduce_171 = happySpecReduce_1  63# happyReduction_171
happyReduction_171 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn69
		 (let TBool s b = happy_var_1 in ExpValue () s $ ValLogical b
	)}

happyReduce_172 = happySpecReduce_1  64# happyReduction_172
happyReduction_172 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn70
		 (ExpValue () (getSpan happy_var_1) $ let (THollerith _ h) = happy_var_1 in ValHollerith h
	)}

happyReduce_173 = happySpecReduce_2  65# happyReduction_173
happyReduction_173 happy_x_2
	happy_x_1
	 =  case happyOut72 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn71
		 (setSpan (getTransSpan happy_var_1 happy_var_2) $ aReverse happy_var_1
	)}}

happyReduce_174 = happySpecReduce_3  66# happyReduction_174
happyReduction_174 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut72 happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_3 of { happy_var_3 -> 
	happyIn72
		 (setSpan (getTransSpan happy_var_1 happy_var_3) $ happy_var_3 `aCons` happy_var_1
	)}}

happyReduce_175 = happySpecReduce_2  66# happyReduction_175
happyReduction_175 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut74 happy_x_2 of { happy_var_2 -> 
	happyIn72
		 (AList () (getTransSpan happy_var_1 happy_var_2) [ happy_var_2 ]
	)}}

happyReduce_176 = happySpecReduce_1  67# happyReduction_176
happyReduction_176 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn73
		 (ExpValue () (getSpan happy_var_1) (let (TLabel _ l) = happy_var_1 in ValInteger l)
	)}

happyReduce_177 = happySpecReduce_1  68# happyReduction_177
happyReduction_177 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn74
		 (ExpValue () (getSpan happy_var_1) (let (TInt _ l) = happy_var_1 in ValInteger l)
	)}

happyReduce_178 = happySpecReduce_1  69# happyReduction_178
happyReduction_178 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (TypeSpec () (getSpan happy_var_1) TypeInteger Nothing
	)}

happyReduce_179 = happySpecReduce_1  69# happyReduction_179
happyReduction_179 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (TypeSpec () (getSpan happy_var_1) TypeReal Nothing
	)}

happyReduce_180 = happySpecReduce_1  69# happyReduction_180
happyReduction_180 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (TypeSpec () (getSpan happy_var_1) TypeDoublePrecision Nothing
	)}

happyReduce_181 = happySpecReduce_1  69# happyReduction_181
happyReduction_181 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (TypeSpec () (getSpan happy_var_1) TypeLogical Nothing
	)}

happyReduce_182 = happySpecReduce_1  69# happyReduction_182
happyReduction_182 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn75
		 (TypeSpec () (getSpan happy_var_1) TypeComplex Nothing
	)}

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	TEOF _ -> happyDoAction 59# tk action sts stk;
	TLeftPar _ -> cont 1#;
	TRightPar _ -> cont 2#;
	TComma _ -> cont 3#;
	TDot _ -> cont 4#;
	TFunction _ -> cont 5#;
	TSubroutine _ -> cont 6#;
	TBlockData _ -> cont 7#;
	TEnd _ -> cont 8#;
	TOpAssign _ -> cont 9#;
	TAssign _ -> cont 10#;
	TTo _ -> cont 11#;
	TGoto _ -> cont 12#;
	TIf _ -> cont 13#;
	TCall _ -> cont 14#;
	TReturn _ -> cont 15#;
	TContinue _ -> cont 16#;
	TStop _ -> cont 17#;
	TPause _ -> cont 18#;
	TDo _ -> cont 19#;
	TRead _ -> cont 20#;
	TWrite _ -> cont 21#;
	TRewind _ -> cont 22#;
	TBackspace _ -> cont 23#;
	TEndfile _ -> cont 24#;
	TCommon _ -> cont 25#;
	TEquivalence _ -> cont 26#;
	TExternal _ -> cont 27#;
	TDimension _ -> cont 28#;
	TType _ "integer" -> cont 29#;
	TType _ "real" -> cont 30#;
	TType _ "doubleprecision" -> cont 31#;
	TType _ "logical" -> cont 32#;
	TType _ "complex" -> cont 33#;
	TData _ -> cont 34#;
	TFormat _ -> cont 35#;
	TBlob _ _ -> cont 36#;
	TInt _ _ -> cont 37#;
	TExponent _ _ -> cont 38#;
	TBool _ _ -> cont 39#;
	TOpPlus _ -> cont 40#;
	TOpMinus _ -> cont 41#;
	TOpExp _ -> cont 42#;
	TStar _ -> cont 43#;
	TSlash _ -> cont 44#;
	TOpOr _ -> cont 45#;
	TOpAnd _ -> cont 46#;
	TOpNot _ -> cont 47#;
	TOpLT _ -> cont 48#;
	TOpLE _ -> cont 49#;
	TOpGT _ -> cont 50#;
	TOpGE _ -> cont 51#;
	TOpEQ _ -> cont 52#;
	TOpNE _ -> cont 53#;
	TId _ _ -> cont 54#;
	TComment _ _ -> cont 55#;
	THollerith _ _ -> cont 56#;
	TLabel _ _ -> cont 57#;
	TNewline _ -> cont 58#;
	_ -> happyError' tk
	})

happyError_ 59# tk = happyError' tk
happyError_ _ tk = happyError' tk

happyThen :: () => LexAction a -> (a -> LexAction b) -> LexAction b
happyThen = (>>=)
happyReturn :: () => a -> LexAction a
happyReturn = (return)
happyThen1 = happyThen
happyReturn1 :: () => a -> LexAction a
happyReturn1 = happyReturn
happyError' :: () => (Token) -> LexAction a
happyError' tk = parseError tk

programParser = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut6 x))

statementParser = happySomeParser where
  happySomeParser = happyThen (happyParse 1#) (\x -> happyReturn (happyOut17 x))

expressionParser = happySomeParser where
  happySomeParser = happyThen (happyParse 2#) (\x -> happyReturn (happyOut53 x))

happySeq = happyDontSeq


makeReal :: Maybe Token -> Maybe Token -> Maybe Token -> Maybe (SrcSpan, String) -> Expression A0
makeReal i1 dot i2 exp =
  let span1   = getSpan (i1, dot, i2)
      span2   = case exp of
                  Just e -> getTransSpan span1 (fst e)
                  Nothing -> span1
      i1Str   = case i1 of { Just (TInt _ s) -> s ; _ -> "" }
      dotStr  = case dot of { Just (TDot _) -> "." ; _ -> "" }
      i2Str   = case i2 of { Just (TInt _ s) -> s ; _ -> "" }
      expStr  = case exp of { Just (_, s) -> s ; _ -> "" } in
    ExpValue () span2 (ValReal $ i1Str ++ dotStr ++ i2Str ++ expStr)

transformations66 =
  [ GroupLabeledDo
  , DisambiguateFunction
  ]

fortran66Parser :: B.ByteString -> String -> ProgramFile A0
fortran66Parser sourceCode filename =
    transform transformations66 $ parse parseState
  where
    parse = evalParse programParser
    parseState = initParseState sourceCode Fortran66 filename

parseError :: Token -> LexAction a
parseError _ = do
    parseState <- get
#ifdef DEBUG
    tokens <- reverse <$> aiPreviousTokensInLine <$> getAlex
#endif
    fail $ psFilename parseState ++ ": parsing failed. "
#ifdef DEBUG
      ++ '\n' : show tokens
#endif
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 19 "<built-in>" #-}
{-# LINE 1 "/usr/local/lib/ghc-7.10.2/include/ghcversion.h" #-}


















{-# LINE 20 "<built-in>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 


{-# LINE 13 "templates/GenericTemplate.hs" #-}





-- Do not remove this comment. Required to fix CPP parsing when using GCC and a clang-compiled alex.
#if __GLASGOW_HASKELL__ > 706
#define LT(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.<# m)) :: Bool)
#define GTE(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.>=# m)) :: Bool)
#define EQ(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.==# m)) :: Bool)
#else
#define LT(n,m) (n Happy_GHC_Exts.<# m)
#define GTE(n,m) (n Happy_GHC_Exts.>=# m)
#define EQ(n,m) (n Happy_GHC_Exts.==# m)
#endif

{-# LINE 46 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Happy_GHC_Exts.Int# Happy_IntList






{-# LINE 67 "templates/GenericTemplate.hs" #-}


{-# LINE 77 "templates/GenericTemplate.hs" #-}










infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
        (happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
        = {- nothing -}
          

          case action of
                0#           -> {- nothing -}
                                     happyFail i tk st
                -1#          -> {- nothing -}
                                     happyAccept i tk st
                n | LT(n,(0# :: Happy_GHC_Exts.Int#)) -> {- nothing -}
                                                   
                                                   (happyReduceArr Happy_Data_Array.! rule) i tk st
                                                   where rule = (Happy_GHC_Exts.I# ((Happy_GHC_Exts.negateInt# ((n Happy_GHC_Exts.+# (1# :: Happy_GHC_Exts.Int#))))))
                n                 -> {- nothing -}
                                     

                                     happyShift new_state i tk st
                                     where new_state = (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#))
   where off    = indexShortOffAddr happyActOffsets st
         off_i  = (off Happy_GHC_Exts.+# i)
         check  = if GTE(off_i,(0# :: Happy_GHC_Exts.Int#))
                  then EQ(indexShortOffAddr happyCheck off_i, i)
                  else False
         action
          | check     = indexShortOffAddr happyTable off_i
          | otherwise = indexShortOffAddr happyDefActions st


indexShortOffAddr (HappyA# arr) off =
        Happy_GHC_Exts.narrow16Int# i
  where
        i = Happy_GHC_Exts.word2Int# (Happy_GHC_Exts.or# (Happy_GHC_Exts.uncheckedShiftL# high 8#) low)
        high = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr (off' Happy_GHC_Exts.+# 1#)))
        low  = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr off'))
        off' = off Happy_GHC_Exts.*# 2#





data HappyAddr = HappyA# Happy_GHC_Exts.Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)


{-# LINE 170 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) sts of
         sts1@((HappyCons (st1@(action)) (_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
         let drop_stk = happyDropStk k stk

             off = indexShortOffAddr happyGotoOffsets st1
             off_i = (off Happy_GHC_Exts.+# nt)
             new_state = indexShortOffAddr happyTable off_i



          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n Happy_GHC_Exts.-# (1#::Happy_GHC_Exts.Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off = indexShortOffAddr happyGotoOffsets st
         off_i = (off Happy_GHC_Exts.+# nt)
         new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail 0# tk old_st _ stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
        happyDoAction 0# tk action sts ( (Happy_GHC_Exts.unsafeCoerce# (Happy_GHC_Exts.I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Happy_GHC_Exts.Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.

